using System;
using System.Text;
using System.Reflection;
using System.Security;
using System.Runtime.InteropServices;

namespace LearnWPF.ZuneTheme
{
    internal class ZuneXPThemePatch
    {
        internal static void FixTheme()
        {
            StringBuilder builder1 = new StringBuilder(260);
            StringBuilder builder2 = new StringBuilder(260);
            if (GetCurrentThemeName(builder1, builder1.Capacity, builder2, builder2.Capacity, null, 0) == 0)
            {
                string themeName = builder1.ToString();

                if (themeName.ToLower().EndsWith("\\zune.msstyles"))
                {
                    //reflect
                    Assembly presentationFrameworkAsm = Assembly.GetAssembly(typeof(System.Windows.Window));
                    if (presentationFrameworkAsm != null)
                    {
                        Type themeWrapper = presentationFrameworkAsm.GetType("MS.Win32.UxThemeWrapper");
                        if (themeWrapper != null)
                        {
                            FieldInfo themeColor = themeWrapper.GetField("_themeColor", BindingFlags.Static | BindingFlags.NonPublic);
                            FieldInfo themeNameField = themeWrapper.GetField("_themeName", BindingFlags.Static | BindingFlags.NonPublic);

                            themeColor.SetValue(null, "metallic");
                            themeNameField.SetValue(null, "luna");
                        }
                    }
                }

            }
        }

        [SuppressUnmanagedCodeSecurity, SecurityCritical, DllImport("uxtheme.dll", CharSet = CharSet.Auto)]
        private static extern int GetCurrentThemeName(StringBuilder pszThemeFileName, int dwMaxNameChars, StringBuilder pszColorBuff, int dwMaxColorChars, StringBuilder pszSizeBuff, int cchMaxSizeChars);
    }
}
